package me.wazup.hideandseek.commands.admin;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Firework;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import me.wazup.hideandseek.managers.FilesManager;
import me.wazup.hideandseek.Arena;
import org.bukkit.entity.Player;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.Customization;
import me.wazup.hideandseek.HideAndSeek;
import me.wazup.hideandseek.commands.SubCommand;

public class PowerupCommand extends SubCommand
{
    public PowerupCommand() {
        super("hideandseek.powerup", false, "Add/Del <Arena>");
    }
    
    public boolean execute(final HideAndSeek hideAndSeek, final Customization customization, final CommandSender commandSender, final String[] array) {
        final Player player = (Player)commandSender;
        if (array.length < 3 || (!array[1].equalsIgnoreCase("add") && !array[1].equalsIgnoreCase("del"))) {
            return false;
        }
        final Arena value = Arena.valueOf(array[2]);
        if (value == null) {
            player.sendMessage((String)customization.messages.get("unknown_arena"));
            return true;
        }
        final FileConfiguration config = FilesManager.getInstance().getConfig("arenas.yml");
        final String string = "Arenas." + value.name + ".powerups";
        if (array[1].equalsIgnoreCase("add")) {
            final Location location = player.getLocation();
            final int i = config.contains(string) ? (config.getConfigurationSection(string).getKeys(false).size() + 1) : 1;
            final Location e = new Location(location.getWorld(), location.getBlockX() + 0.5, (double)(location.getBlockY() + 1), location.getBlockZ() + 0.5);
            config.set(string + "." + i + ".world", (Object)e.getWorld().getName());
            config.set(string + "." + i + ".x", (Object)e.getX());
            config.set(string + "." + i + ".y", (Object)e.getY());
            config.set(string + "." + i + ".z", (Object)e.getZ());
            FilesManager.getInstance().saveConfig("arenas.yml");
            value.powerups.add(e);
            player.sendMessage(customization.prefix + "You have added a powerup spawner with the id of " + ChatColor.AQUA + i + ChatColor.GOLD + " to the arena " + ChatColor.YELLOW + value.name);
            e.getWorld().spawn(e, (Class)Firework.class);
        }
        else {
            if (value.powerups.isEmpty()) {
                player.sendMessage(customization.prefix + "There are no powerups locations to remove in this arena!");
                return true;
            }
            final int size = value.powerups.size();
            value.powerups.remove(size - 1);
            config.set("Arenas." + value.name + ".powerups." + size, (Object)null);
            FilesManager.getInstance().saveConfig("arenas.yml");
            player.sendMessage(customization.prefix + "You have removed a powerup spawner with the id of " + ChatColor.AQUA + size + ChatColor.GOLD + " from the arena " + ChatColor.YELLOW + value.name);
        }
        return true;
    }
}
